// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Fx_core.pas' rev: 11.00

#ifndef Fx_coreHPP
#define Fx_coreHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Fx_version.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Fx_core
{
//-- type declarations -------------------------------------------------------
#pragma pack(push,1)
struct TfxColor
{
	
	union
	{
		struct 
		{
			Byte R;
			Byte G;
			Byte B;
			Byte A;
			
		};
		struct 
		{
			Word HiWord;
			Word LoWord;
			
		};
		struct 
		{
			unsigned Color;
			
		};
		
	};
} ;
#pragma pack(pop)

typedef TfxColor *PfxColor;

typedef TfxColor TfxColorArray[65536];

typedef TfxColorArray *PfxColorArray;

#pragma pack(push,1)
struct TfxPoint
{
	
public:
	float x;
	float y;
} ;
#pragma pack(pop)

class DELPHICLASS TfxAdapter;
class PASCALIMPLEMENTATION TfxAdapter : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	/*         class method */ static bool __fastcall Support(TMetaClass* vmt, System::TObject* AObject) = 0 ;
	/*         class method */ static System::TObject* __fastcall Create(TMetaClass* vmt, int Width, int Height) = 0 ;
	/*         class method */ static int __fastcall GetWidth(TMetaClass* vmt, System::TObject* AObject) = 0 ;
	/*         class method */ static int __fastcall GetHeight(TMetaClass* vmt, System::TObject* AObject) = 0 ;
	/*         class method */ static void * __fastcall GetScanline(TMetaClass* vmt, System::TObject* AObject, int Line) = 0 ;
	/* virtual class method */ virtual void * __fastcall GetStartLine(TMetaClass* vmt, System::TObject* AObject);
	/* virtual class method */ virtual void __fastcall BeginUpdate(TMetaClass* vmt, System::TObject* AObject);
	/* virtual class method */ virtual void __fastcall EndUpdate(TMetaClass* vmt, System::TObject* AObject);
	/*         class method */ static void __fastcall SetSize(TMetaClass* vmt, System::TObject* AObject, const int AWidth, const int AHeight) = 0 ;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TfxAdapter(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TfxAdapter(void) { }
	#pragma option pop
	
};


typedef TMetaClass* TfxAdapterClass;

#pragma option push -b-
enum TfxValueType { feValueFloat, feValuePoint, feValueColor, feValueBitmap };
#pragma option pop

struct TfxValueRec
{
	
public:
	AnsiString Name;
	AnsiString Desc;
	TfxValueType ValueType;
	Variant Value;
	Variant Min;
	Variant Max;
	Variant Default;
} ;

typedef DynamicArray<TfxValueRec >  TfxValueRecArray;

struct TfxFilterRec
{
	
public:
	AnsiString Name;
	AnsiString Desc;
	DynamicArray<TfxValueRec >  Values;
} ;

class DELPHICLASS TfxFilter;
class PASCALIMPLEMENTATION TfxFilter : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
public:
	Variant operator[](AnsiString Index) { return Values[Index]; }
	
private:
	Variant __fastcall GetValues(AnsiString Index);
	void __fastcall SetValues(AnsiString Index, const Variant &Value);
	System::TObject* __fastcall GetValuesAsBitmap(AnsiString Index);
	void __fastcall SetValuesAsBitmap(AnsiString Index, const System::TObject* Value);
	TfxPoint __fastcall GetValuesAsPoint(AnsiString Index);
	void __fastcall SetValuesAsPoint(AnsiString Index, const TfxPoint &Value);
	void __fastcall SetInputFilter(const TfxFilter* Value);
	
protected:
	DynamicArray<TfxValueRec >  FValues;
	System::TObject* FInput;
	System::TObject* FTarget;
	System::TObject* FOutput;
	bool FProcessing;
	bool FModified;
	TfxFilter* FInputFilter;
	
public:
	__fastcall virtual TfxFilter(void);
	__fastcall virtual ~TfxFilter(void);
	/*         class method */ static TfxFilterRec __fastcall FilterAttr(TMetaClass* vmt) = 0 ;
	virtual void __fastcall Apply(void) = 0 ;
	__property Variant Values[AnsiString Index] = {read=GetValues, write=SetValues/*, default*/};
	__property System::TObject* ValuesAsBitmap[AnsiString Index] = {read=GetValuesAsBitmap, write=SetValuesAsBitmap};
	__property TfxPoint ValuesAsPoint[AnsiString Index] = {read=GetValuesAsPoint, write=SetValuesAsPoint};
	__property TfxFilter* InputFilter = {read=FInputFilter, write=SetInputFilter};
};


typedef TMetaClass* TfxFilterClass;

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Classes::TStrings* Filters;
extern PACKAGE Classes::TList* Adapters;
extern PACKAGE TfxPoint __fastcall fxPoint(float x, float y);
extern PACKAGE bool __fastcall VarIsPoint(const Variant &V);
extern PACKAGE Variant __fastcall VarFromPointXY(float x, float y);
extern PACKAGE Variant __fastcall VarFromPoint(const TfxPoint &P);
extern PACKAGE TfxPoint __fastcall VarToPoint(const Variant &V);
extern PACKAGE float __fastcall VarToPointX(const Variant &V);
extern PACKAGE float __fastcall VarToPointY(const Variant &V);
extern PACKAGE bool __fastcall VarIsObject(const Variant &V);
extern PACKAGE Variant __fastcall VarFromObject(System::TObject* AObject);
extern PACKAGE System::TObject* __fastcall VarToObject(const Variant &V);
extern PACKAGE System::TObject* __fastcall fxCreateObject(System::TObject* AObject, int Width, int Height);
extern PACKAGE int __fastcall fxGetWidth(System::TObject* AObject);
extern PACKAGE int __fastcall fxGetHeight(System::TObject* AObject);
extern PACKAGE void __fastcall fxSetSize(System::TObject* AObject, const int AWidth, const int AHeight);
extern PACKAGE void __fastcall RegisterAdapter(TMetaClass* Adapter);
extern PACKAGE void __fastcall UnregisterAdapter(TMetaClass* Adapter);
extern PACKAGE TMetaClass* __fastcall FindAdapter(System::TObject* AObject);
extern PACKAGE TfxFilter* __fastcall FilterByName(AnsiString AName);
extern PACKAGE TMetaClass* __fastcall FilterClassByName(AnsiString AName);
extern PACKAGE void __fastcall RegisterFilter(AnsiString Category, TMetaClass* Filter);
extern PACKAGE void __fastcall FillCategory(Classes::TStrings* AList);
extern PACKAGE void __fastcall FillFiltersInCategory(AnsiString Category, Classes::TStrings* AList);
extern PACKAGE TfxFilterRec __fastcall FilterRec(AnsiString AName, AnsiString ADesc, TfxValueRec * AValues, const int AValues_Size);
extern PACKAGE TfxValueRec __fastcall FilterValueRec(AnsiString AName, AnsiString ADesc, TfxValueType AType, const Variant &ADefault, const Variant &AMin, const Variant &AMax);

}	/* namespace Fx_core */
using namespace Fx_core;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Fx_core
